<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');

/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2006 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.0 - Last modified 2/6/2006
*/


// ===================================================================
// Misc
//
// Microtime
function get_microtime() {
	$mtime = microtime();
	$mtime = explode(' ', $mtime);
	return doubleval($mtime[1]) + doubleval($mtime[0]);
}

// Magic quotes
if (!get_magic_quotes_gpc()) {
	function slashit($in) {
		return addslashes($in);
	}
} else {
	set_magic_quotes_runtime(0);

	function slashit($in) {
		return $in;
	}
}


// ===================================================================
// Error reporting
//
// Blank location sends to index.php
// "${loc};in" logs in, "${loc};out" logs out
function all_done($location = 'index.php') {
	global $dbconn;
	@mysql_close($dbconn);

	$url = $location;

	// Hack to fix IIS cookie issue
	if (strstr ($location, ';')) {
		list ($url, $stat) = explode (';', $location);

		if (strstr (strtoupper ($_SERVER['SERVER_SOFTWARE']), 'IIS/')) {
			if ($stat == 'in') {
				$mess = 'Thanks for logging in!';
			} elseif ($stat == 'out') {
				$mess = 'You have sucessfully logged out.';
			} else {
				'Your login has been updated.';
			}

			echo <<<EOF
<html>
<head>
	<title>Redirect</title>
	<meta http-equiv="refresh" content="3;url={$url}">
</head>
<body>
	<p style="text-align: center; padding: 15px; border: 2px black solid;">
		<strong>{$mess}</strong><br /><br />If you are not redirected in 3 seconds, click <a href="{$url}">here</a>.
	</p>
</body>
</html>
EOF;
			exit ();
		}
	}

	header ('Location: '.$url);
	exit;
}

function report_err($error = '', $small_header = FALSE) {
	global $dbconn;
	@mysql_close($dbconn);

	if (empty ($error)) {
		$error = 'An error occured.  Please try again.';
	}
	if ($small_header) {
		$small_header = '&s=1';
	}

	header ('Location: error.php?error='.urlencode($error).$small_header);
	exit;
}


// ===================================================================
// Untainting
//
// Check for chars that break database
function badChars($text) {
	// Code from PHP.net

	$illegal = array('\'', '"', '$', '#', '&', '+', '=', '*', '/', '\\', ':', ';');
	$garb = array();

	foreach ($illegal as $k) {
		while (($j = strpos ($text, $k)) !== FALSE) {
			$garb[] = $text{$j};
			$text = substr ($text, 0, $j).substr ($text, $j + 1);
		}
	}
	$garb = array_unique ($garb);

	return $garb;
}


// Prepare path input (UNIX/URI only)
function strip_path($in) {
	// Strip trailing slash(es)
	$in = preg_replace ('/\/+$/', '', $in);

	// Strip root, but not backtick
	$in = preg_replace ('/^(\.\/)+/', '', $in);

	return $in;
}


// ===================================================================
// File + filedata ops
//
// Checks for empty file
function file_not_empty($in) {
	if (file_exists ($in) && filesize ($in) > 0) {
		return 1;
	} else {
		return 0;
	}
}


// PHP < 4.3 fix
if (!function_exists ('file_get_contents')) {
	function file_get_contents($file) {
		if (file_exists ($file)) {
			$size = @filesize ($file);
			$fp = @fopen ($file, 'rb');
			if ($fp && $size > 0) {
				$contents = fread ($fp, $size);
				fclose ($fp);
				return $contents;
			}
			trigger_error ("file_get_contents('{$file}'): cannot open for reading", E_USER_NOTICE);
		}
		// No data
		return;
	}
}


function file_unlock($in, $force = FALSE) {
	/*
		Wrapper for unlink().  $force bypasses wrapper.

		UNIX:  Helps to prevent permission errors with unwritable files.  These files may usually be deleted, even if they cannot be opened for writing.

		WIN32:  PHP has a problem with its file virtualization layer which causes slow deletes.  Attempting to fopen() a deleted file within a few seconds of deleting it will return a permission denied error.
	*/

	if (file_exists ($in)) {
		$win_kill = FALSE;
		if (strtoupper (substr (PHP_OS, 0, 3)) == 'WIN')
			$win_kill = TRUE;

		if (!$force && $win_kill) {
			// OK, this is Windows, and PHP doesn't like it
			$temp = dirname($in).'/'.'junk_'.rand(0, 32768).'.tmp';

			if (!@rename ($in, $temp)) {
				// This sucks, but is rare
				if (!@unlink ($in)) {
					return FALSE;
				}
			} else {
				if (!@unlink ($temp)) {
					return FALSE;
				}
			}
		} else {
			// UNIX, or brute force
			if (!@unlink ($in)) {
				return FALSE;
			}
		}
	}
	return TRUE;
}


function get_filetype(&$data, $type = '') {
	// Get types in approx. order of popularity
	// If no match, use file ext as type

	if (substr ($data, 0, 8) == "\x89PNG\x0D\x0A\x1A\x0A") {
		$type = 'png';
	} elseif (substr ($data, 0, 2) == "\xFF\xD8") {
		// JFIF only.  EXIF is not allowed.
		$type = 'jpg';
	} elseif (substr ($data, 0, 3) == 'GIF') {
		$type = 'gif';
	} elseif (substr ($buffer, 0, 2) == 'BM') {
		$type = 'bmp';
	} elseif (substr ($data, 0, 23) == "\x00\x00\x00\x0CjP\x20\x20\x0D\x0A\x87\x0A\x00\x00\x00\x14ftypjp2") {
		$type = 'jp2';
	} elseif (substr ($buffer, 0, 4) == '8BPS') {
		// Note: 8-bit, 16-bit, and HDR images have same header
		$type = 'psd';
	} elseif (substr ($data, 0, 2) == 'PK') {
		$type = 'zip';
	} elseif (substr ($data, 0, 3) == 'FWS') {
		$type = 'swf';
	} elseif (substr ($data, 0, 3) == 'CWS') {
		$type = 'swf';
	}

	return $type;
}


function clean_safety_saves() {
	global $cfg;
	global $dbconn, $OekakiPoteto_Prefix;

	// Check for old safety saves
	$wip_kill = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta WHERE postlock=0 AND (DATE_ADD(postdate, INTERVAL {$cfg['safety_storetime']} DAY) <= NOW()) LIMIT 0, 5");

	$total = mysql_num_rows ($wip_kill);

	if ($total) {
		include ('paintsave.php');
		while ($result = mysql_fetch_array ($wip_kill)) {
			kill_picture_slot($result['PIC_ID']);
		}
	}
}


// ===================================================================
// Decoders
//
function get_age($in) {
	// Check if an age already.
	// Age has no dashes.
	if (empty ($in)) {
		return '';
	}
	if (strpos ($in, '-') === FALSE) {
		return intval ($in);
	}

	// Age from birthday
	// Thanks to Jean-Marc on the LiquidPulse.net forum
	list ($year, $month, $day) = explode ('-', $in);
	$z = -5; // Timezone

	$yeardiff =  gmdate ('Y', time() + $z * 3600) - intval($year);
	$monthdiff = gmdate ('m', time() + $z * 3600) - intval($month);
	$daydiff =   gmdate ('j', time() + $z * 3600) - intval($day);

	if (($monthdiff < 0) || (($monthdiff == 0) && ($daydiff <= 0) )) {
		$age = $yeardiff - 1;
	} else {
		$age = $yeardiff;
	}

	return $age;
}

function decode_birthday($year, $month, $day) {
	$year  = (int) $year;
	$month = (int) $month;
	$day   = (int) $day;

	if ($year < 1900) {
		return '';
	}

	if ($month < 1 || $month > 12) {
		$month = '??';
	} else {
		$month = sprintf ('%02d', $month);
	}
	if ($day < 1 || $day > 31) {
		$day = '??';
	} else {
		$day = sprintf ('%02d', $day);
	}

	return $year.'-'.$month.'-'.$day;
}


// Determine best "image_size" param for oekaki applets.
function applet_image_size_param($size_x, $size_y, $ratio = .35) {
	/*
	Input: canvas size (x, y), ratio (optional)
	Output: max filesize, in K

	A lot of testing with actual oekakis showed me that for images larger than 10K, average PNG compression is between .20 to .25, while average JPEG is .12 (low quality) to .25 (medium quality).  It's reasonable to say that if a PNG is getting a worse compression ratio than this, it is the wrong format, and JPEG should be used.  We'll use .35 as the ratio, since the "original" images should still be treated as archive quality.  This is intended to reduce server space usage -- let the thumbnail generator worry about page-view bandwidth.
	*/

	$base_size = 20; // Minimum return, in K
	$area = $size_x * $size_y * 3;
	$max_file_size = round (($area * $ratio) / 1024);

	return ($max_file_size > $base_size) ? $max_file_size : $base_size;
}


// ===================================================================
// Web printing functions
//
function p_line($line) {
	echo '<p>'.$line."</p>\n";
}


function web_line($line = '') {
	echo $line."<br />\n";
}


function sql_check($result, $extra = '') {
	if (!$result) {
		echo mysql_error();
		if (!empty ($extra)) {
			echo ' ['.$extra.']';
		}
		echo "<br />\n";
		return 0;
	}
	return 1;
}


// Version number processing
function version_split($input) {
	// Returns keyed array of "usable" numbers
	// INPUT: 'modname-x.y.z', 'x.y.z', 'modname-x.y', 'x.y' patterns
	/* OUTPUT:
		'mod'=>'modname'
		'ver'=>"%03d%03d%03d" (5.12.14 = 005012014),
		'major'=>major num
		'minor'=>minor num
		'rev'=>revision num (build)
	*/

	if ($input == 'Wac1.0') {
		// 'Wac1.0' fix
		return array ('mod'=>'wac', 'ver'=>1000000, 'major'=>1, 'minor'=>0, 'rev'=>0 );
	}

	// Note reverse search, so dashes can be in mod name
	$split = strrpos ($input, '-');

	if ($split) {
		// If there's a dash, get the mod name
		$ver_name = substr ($input, 0, $split);
		$ver_num  = substr ($input, $split + 1);
		$small = explode ('.', $ver_num);
	} else {
		$small = explode ('.', $input);
	}

	if (count($small) > 1) {
		// Major & minor required, revision optional
		if (!defined($small[2])) {
			$small[2] = 0;
		}
		$ver_num = ($small[0] * 1000000) + ($small[1] * 1000) + intval ($small[2]);

		return array ('mod'=>$ver_name, 'ver'=>$ver_num, 'major'=>$small[0], 'minor'=>$small[1], 'rev'=>$small[2] );
	} else {
		// Not a valid number!
		return 0;
	}
}


// Returns a string from an array, with seperators and delimiters.
function make_list(&$array, $sep, $delimiter = '') {
	$list = '';
	$items = count ($array);

	if ($items == 1) {
		return $delimiter.$array[0].$delimiter;
	} elseif ($items > 0) {
		for ($i = 0; $i < ($items - 1); $i++) {
			$list .= $delimiter.$array[$i].$delimiter.$sep;
		}
		$list .= $delimiter.$array[$i].$delimiter;

		return $list;
	}
}


// "Not Empty" Echo.  Prints nothing, or alternate $if_empty, if $string is empty.
function ne_echo($string, $if_empty, $format = '') {
	$string = trim ($string);
	if (!empty ($string)) {
		if (!empty ($format)) {
			echo (str_replace ('{s}', $string, $format));
		} else {
			echo $string;
		}
	} else {
		echo $if_empty;
	}
	return;
}


// Deluxe page numbers
// Takes a keyed array of paramaters ($in) and returns an HTML-formatted block of page numbers
function full_page_numbers($first, $current, $total, $display, $link, $in) {
	/*
	$first = First page number.  Some BBSes use 0 as the first page, others 1.
	$display = Number of pages to show per side of the current page.  0 = use default.

	$in = array:
	prev_enabled  => Linked "Prev", parsed for '{page}'
	prev_disabled => Unlinked "Prev"
	next_enabled  => Linked "Next", parsed for '{page}'
	next_disabled => Unlinked "Next"
	button_sep    => Seperates Prev/Next from numbers
	link_format   => Link format (for classes, etc), parsed for '{page}'
	active_format => Span for current [active] number, parsed for '{page}'
	elipses       => Seperator for first/last numbers and all others
	page_sep      => Seperator between numbers
	*/

	// Fixes offset issue with some BBSes
	function offset_replace($offset, $number, $string) {
		$old = array ('{page_link}', '{page}');
		$new = array ($number + $offset, $number);
		return str_replace ($old, $new, $string);
	}

	// Set up
	$output = '';
	if ($display < 1) {
		$display = 4;
	}
	if ($first == 0) {
		$offset = -1;
		$first += 1;
		$current += 1;
	} else {
		$offset = 0;
	}
	$page_link = str_replace ('{link}', $link, $in['link_format']);
	$in['prev_enabled'] = str_replace ('{link}', $link, $in['prev_enabled']);
	$in['next_enabled'] = str_replace ('{link}', $link, $in['next_enabled']);

	// Get our extremes
	$list_start = 1;
	$list_end   = $total;
	if ($current > $display + 1) {
		$list_start = $current - $display;
	}
	if ($total - $current > $display) {
		$list_end = $current + $display;
	}

	// Print start block
	if ($current > 1) {
		$output .= offset_replace($offset, $current - 1, $in['prev_enabled']);
	} else {
		$output .= $in['prev_disabled'];
	}
	$output .= $in['button_sep'];

	// Print start number?
	if ($list_start > 1) {
		$output .= offset_replace($offset, 1, $page_link);
		$output .= $in['elipses'];
	}

	// Print all numbers
	for ($i = $list_start; $i <= $list_end; $i++) {
		if ($i == $current) {
			$output .= offset_replace($offset, $i, $in['active_format']);
		} else {
			$output .= offset_replace($offset, $i, $page_link);
		}
		if ($i != $list_end) $output .= $in['page_sep'];
	}

	// Print end number?
	if ($list_end < $total) {
		$output .= $in['elipses'];
		$output .= offset_replace($offset, $total, $page_link);
	}

	// Print end block
	$output .= $in['button_sep'];
	if ($current < $total) {
		$output .= offset_replace($offset, $current + 1, $in['next_enabled']);
	} else {
		$output .= $in['next_disabled'];
	}

	return $output;
}


// Simple page numbers (no images)
// Easy, format-free wrapper for full_page_numbers()
function quick_page_numbers($first, $current, $total, $display, $link) {
	$page_settings = array (
		'prev_enabled'  => '<a href="{link}">&lt;&lt;PREV</a>',
		'prev_disabled' => '&lt;&lt;PREV',
		'next_enabled'  => '<a href="{link}">NEXT&gt;&gt;</a>',
		'next_disabled' => 'NEXT&gt;&gt;',
		'button_sep'    => ' &middot; ',
		'link_format'   => '<a href="{link}">[{page}]</a>',
		'active_format' => '<b>[{page}]</b>',
		'elipses'       => ' ... ',
		'page_sep'      => ' '
	);

	return full_page_numbers($first, $current, $total, $display, $link, $page_settings);
}

?>